<?php 

class km_product_sync{
	
	public function km_update_product($product_data){
		
		  		
		$product_name =  $product_data["Product.description"];
		 
		$product_id = $this->km_synced_product_id($product_data["Product.id"]);		
		  
		 if(!$product_id){
			 
            $post = array( 
                'post_status' => 'publish',
                'post_title' => $product_name,
                'post_parent' => '',
                'post_type' => 'product'
            );
			 
            $product_id = wp_insert_post($post);
			 
        }else{
		      $args = array(
		        'ID' => $product_id,
		        'post_title' => $product_name,
	        );			
			 $result = wp_update_post($args, true);
            if (is_wp_error($result)) {				
                $errors = $result->get_error_messages();
                foreach ($result as $error) {
                    //$this->ch_error($error, 'update_product.log');
                }
            }
			
		} 
		
		//var_dump($product_id);
		
		if($product_id > 0){
			
			$product = wc_get_product($product_id);			
			$product->set_description( $product_data['Product.descriptionLong'] );
			$product->set_short_description($product_data['Product.descriptionShort']);			
			$product->set_price($product_data["Product.price"]);
			$product->set_regular_price($product_data["Product.price"]);
			//$product->set_sale_price($product_data["sale_price"]); 
			$product->set_name($product_name); 
			$product->set_stock_quantity($product_data["Product.quantity"]);
			 	
			/* if(!empty($product_data["Product.sku"])){
				$product->set_sku($product_data["Product.sku"]);			
			} */	
			// $product->set_status($product_data["status"]); 			
			 
			//$product->set_weight($product_data["weight"]); 
			//$product->set_featured($product_data["featured"]); 
			//$product->set_date_on_sale_from($product_data["date_on_sale_from"]); 
			//$product->set_date_on_sale_to($product_data["date_on_sale_to"]); 
			//$product->set_manage_stock($product_data["manage_stock"]); 			 
			//$product->set_stock_status($product_data["stock_status"]); 
			
			 
			$product->set_weight($product_data["Product.weight"]); 
			//$product->set_length($product_data["length"]); 
			//$product->set_width($product_data["width"]); 
			//$product->set_height($product_data["height"]);  
			
			 $category_ids = array();			
			$ProductGroups = !empty($product_data["Product.ProductGroup"])? $product_data["Product.ProductGroup"] : array();
			
			foreach($ProductGroups as $Group){
				$term_name = $Group["ProductGroup.description"];
				if(!empty($term_name)){
					$category_ids[] = $this->save_taxonomy_terms($term_name,'cat');				
				} 
			}
						
			$product->set_category_ids($category_ids);
			
			// Add product thumb			
			if(!empty($product_data["Product.image"])){		
				$img = array("src"=>"https://www.kundenmeister.com/crm".$product_data["Product.image"]);
				$this->km_set_product_images($product,array($img)); 
				update_post_meta($product_id,"_kundenmeister_src","https://www.kundenmeister.com/crm".$product_data["Product.image"]); 
			} 
			
			// add product meta 
			update_post_meta($product_id,"kundenmeister_product_id",$product_data["Product.id"]); 
			update_post_meta($product_id,"_kundenmeister_product",$product_data); 
			
						
			/*
			$data_attributes = isset($product_data["attributes"])? $product_data["attributes"] : array();
			$attributes = array();
			foreach($data_attributes as $data_attribute){
				$id = wc_attribute_taxonomy_id_by_name( $data_attribute['name'] );
				
				$attribute = new WC_Product_Attribute();
				$attribute->set_id( $id );
				$attribute->set_name( $data_attribute['name'] );
				$attribute->set_options( $data_attribute["options"] );
				$attribute->set_position( $data_attribute['position'] );
				$attribute->set_visible($data_attribute['visible']);
				$attribute->set_variation($data_attribute['variation']);
				//$attribute->set_variation($vendor_id);
				$attributes[] = $attribute;
			}
			
			$product->set_attributes( $attributes );
			*/
			$product->save();	
			 		
			//wc_delete_product_transients($product_id);
		}
		
		return $product_id;
		 
	}
	// Save taxonomy if not exits 	
	public function save_taxonomy_terms($term_name, $taxonomy = 'cat'){
		$term_id = 0;   
		$term_data = get_term_by( 'name', $term_name, 'product_' . $taxonomy );
		if($term_data){
			$term_id = $term_data->term_id;			 
		}else{
			$parent = 0;
			$new_cat = wp_insert_term($term_name, 'product_' . $taxonomy , array('slug' => $term_name, 'parent' => $parent));
			if (!is_wp_error($new_cat)) {
				$term_id = $new_cat['term_id'];
			}			
		}
        return $term_id;
    }
	
	// Get product by sync product id.
	function km_synced_product_id($to_product_id){
		
		global $wpdb;		 
		$sql = "SELECT posts.ID  FROM $wpdb->posts AS posts  LEFT JOIN $wpdb->postmeta AS postmeta ON ( posts.ID = postmeta.post_id )  WHERE posts.post_type IN ( 'product' )  and postmeta.meta_key = 'kundenmeister_product_id'  and postmeta.meta_value = %s  LIMIT 1";
		
		$product_id = $wpdb->get_var($wpdb->prepare($sql,$to_product_id)); 
				 
		return ($product_id) ? intval($product_id) : 0; 		
	}
	
	// save product images 
	function km_set_product_images( $product,$images) {
		$product_id = $product->get_id();
		if ( is_array( $images ) ) {			 
			$gallery = array();
			foreach ( $images as $k=>$image ) {
				$to_attachment_id = isset( $image['id'] ) ? absint( $image['id'] ) : 0;
				$to_attachment_src = isset( $image['src'] ) ? esc_url_raw( $image['src'] ) : "";
				$to_attachment_name = basename($to_attachment_src);;
				//echo "<br>";
				
				$attachment_id = $this->find_upload_image($to_attachment_name);
				//$attachment_id = 0;

				 
				if ( 0 === $attachment_id && !empty($to_attachment_src)) {
					$upload = wc_rest_upload_image_from_url($to_attachment_src);

					if (!is_wp_error( $upload ) ) { 
						
						// $log_file = "image_upload_error_".$product->get_id()."_.log";	 
						//$msg = '\n -- '.$product_id ." ---> ".$upload->get_error_message();	 
						//
						
						$attachment_id = wc_rest_set_uploaded_image_as_attachment( $upload, $product->get_id() ); 
					}else{
					    /***
						echo "<br><br>";
					    print_r($upload->get_error_codes());
					    echo "<br>";
					    print_r($upload->get_error_message());  
						***/
					}
				} 
				//echo $attachment_id." -- ".$to_attachment_name;
				
				
				if($attachment_id > 0){
					
					update_post_meta( $attachment_id, '_kundenmeister_src', $to_attachment_name);
					
					if ( ! wp_attachment_is_image( $attachment_id ) ) {
						/* 
						throw new WC_REST_Exception( 'woocommerce_product_invalid_image_id', sprintf( __( '#%s is an invalid image ID.', 'woocommerce' ), $attachment_id ), 400 )  */;
					}

					if ( $k ==0 ) {
						$product->set_image_id( $attachment_id );
					} else {
						$gallery[] = $attachment_id;
					}

					// Set the image alt if present.
					if ( ! empty( $image['alt'] ) ) {
						update_post_meta( $attachment_id, '_wp_attachment_image_alt', wc_clean( $image['alt'] ) );
					}

					// Set the image name if present.
					if ( ! empty( $image['name'] ) ) {
						wp_update_post( array( 'ID' => $attachment_id, 'post_title' => $image['name'] ) );
					}
					
					
				} 
			}

			 if ( ! empty( $gallery ) ) {
				$product->set_gallery_image_ids( $gallery );
			} 
			 
		} else {
			$product->set_image_id( '' );
			$product->set_gallery_image_ids( array() );
		}
		$product->save();
		return $product;
	}
	// find already syncted 
	function find_upload_image($to_attachment_src){
		
		global $wpdb;
		$meta_key = '_kundenmeister_src';
		$meta_value = $to_attachment_src;
		
		$sql = "SELECT meta.post_id  FROM $wpdb->postmeta AS meta WHERE meta.meta_key = %s and meta.meta_value = %s LIMIT 1";
		
		$product_id = $wpdb->get_var($wpdb->prepare($sql,$meta_key,$meta_value));	 
		return ($product_id) ? intval($product_id) : 0; 
	}
	
	
	
}

?>