<?php 
/*
Plugin Name: WooCommerce to KundenMeister Integration
Plugin Author: KundenMeister
Author: KundenMeister
Author URI: https://www.kundenmeister.com/
Description: This plugin provides integration to sync products from KundenMeister to WooCommerce and when order is placed, it will be sent to KundenMeister via API. It also generates Invoice for that order on KundenMeister and create that customer there.
Version: 1.0.0
Text Domain: kundenmeister
*/

add_action( 'admin_enqueue_scripts', "kundenmeister_enqueue_scripts");
if(!function_exists('kundenmeister_enqueue_scripts')):
 function kundenmeister_enqueue_scripts() {
	 
	wp_enqueue_style( 'kundenmeister_css', plugins_url('assets/css/kundenmeister-admin-style.css',__FILE__));
	
	wp_enqueue_script('kundenmeister_js',plugins_url('assets/js/kundenmeister-admin.js',__FILE__),array("jquery"),'1.0.0', true);	

	wp_localize_script( "kundenmeister_js",'km',array("ajaxurl"=>admin_url('admin-ajax.php')));

}
endif;
include("classes/class-kundenmeister-api.php");
include("classes/class-wc-sync-product.php");
include("kundenmeister-order.php");

if(!function_exists('kundenmeister_product_sync')):
function kundenmeister_product_sync() {
	add_menu_page(
		__( 'KundenMeister API Settings', 'kundenmeister' ),
		__( 'KundenMeister API Settings', 'kundenmeister' ),
		'manage_options',
		'kundenmeister_settings',
		'kundenmeister_api_setting',
		'dashicons-admin-generic');
}
endif;
add_action( 'admin_menu', 'kundenmeister_product_sync');

if(!function_exists('kundenmeister_api_setting')):
function kundenmeister_api_setting(){
     
	if(isset($_POST['km_submit_btn'])){
		
	  
		$km_applicationSecret = $_POST['km_applicationSecret'];
        update_option('km_applicationSecret',$km_applicationSecret);
		
		$km_applicationId = $_POST['km_applicationId'];
        update_option('km_applicationId',$km_applicationId);
		
		
		$km_api = new kundenmeister_api;
			/* get accessToken */
		
		$km_res = $km_api->km_post_request("auth/application",array("applicationId"=>$km_applicationId,"applicationSecret"=>$km_applicationSecret));
		
		if(isset($km_res["accessToken"])){
			update_option("km_accessToken",$km_res["accessToken"]);
		}
		
		      
    }
	
    $km_applicationId = get_option('km_applicationId');
    $km_applicationSecret = get_option('km_applicationSecret');
    
	
    $checked_cat_list = get_option('km_checked_category');
    $is_sync_value = get_option('km_is_sync');
    $syn_frequency_choice = get_option('km_sync_frequency');   
	 
	  $taxonomy     = 'product_cat';
      $orderby      = 'name';  
      $hierarchical = 1;      // 1 for yes, 0 for no  
      $title        = '';  
      $empty        = 0;
    
      $args = array(
             'taxonomy'     => $taxonomy,
             'orderby'      => $orderby,
             'hierarchical' => $hierarchical,
             'title_li'     => $title,
             'hide_empty'   => $empty,
            
      );
	  
     $all_categories = get_categories( $args );
	  
    ?>    
	<div class="km_preloader" style="display:none">
		<img src="<?=site_url()."/wp-admin/images/spinner-2x.gif"?>" > 
	</div>
        <h2><?php echo __('KundenMeister API Settings','kundenmeister');?></h2>        
		
		<?php 
		 
		if(isset($km_res["error"])){
			echo '<div class="error notice  is-dismissible"><p>'.$km_res["message"].'</p></div>';  
		}elseif(isset($km_res["accessToken"])){
			echo  '<div class="updated  notice  is-dismissible"><p>Saved successfully</p></div>';
		} 
		
		?>
        <form method="post" >
		
        <table>
            <tr>
                <td>
                    <label for="km_applicationId"><?php echo __('API Id:','kundenmeister');?></label>
                </td> 
                <td>
                    <input type="text" name="km_applicationId" id="km_applicationId" value="<?php echo $km_applicationId;?>">
                </td>
            </tr>
			<tr>
                <td>
                    <label for="km_applicationSecret"><?php echo __('Application Secret:','kundenmeister');?></label>
                </td>
                <td>
                    <input type="text" name="km_applicationSecret" id="km_applicationSecret" value="<?php echo $km_applicationSecret;?>">
                </td>
            </tr>
			<tfoot>
				
			</tfoot>
			</table>
			<p>
                <input type="submit" name="km_submit_btn" class= " button km_submit_btn" value="Save"/> 
			</p>
        </form>
		<hr>
		<p>
			<button type="button" class="button" id="km_sync_products_btn" > <?php echo  __('Sync Products','kundenmeister');?> </button>
		</p>
		<div id="km_message" >
		</div>
		 
		<?php 
		//echo WP_PLUGIN_DIR ;
		// echo site_url()."/wp-content/plugins/kundenmeister-integration/kundenmeister-cron.php";
	}

endif;

if(!function_exists('kundenmeister_sync_products')):
function kundenmeister_sync_products($skip=0){
	
	$km_api = new kundenmeister_api;
	$km_pro_sync = new km_product_sync;	
	
	$select = 'select=["Product.ProductGroup.id", 
						"Product.ProductGroup.description",
						"Product.id",
						"Product.languageCode",
						"Product.languageParentId",
						"Product.productParentId",
						"Product.inShop",
						"Product.description",
						"Product.text",
						"Product.period",
						"Product.price",
						"Product.parent",
						"Product.link",
						"Product.seo",
						"Product.descriptionShort",
						"Product.descriptionLong",
						"Product.descriptionExtra",
						"Product.metaDescription",
						"Product.metaKeyword",
						"Product.model",
						"Product.quantity",
						"Product.image",
						"Product.thumb",
						"Product.sortOrder",
						"Product.status",
						"Product.dateAdded",
						"Product.salesTax",
						"Product.originalPrice",
						"Product.depositAmount",
						"Product.isCombinedProduct",
						"Product.updateTime",
						"Product.size",
						"Product.sizeUnit",
						"Product.weight",
						"Product.weightUnit",
						"Product.costUnit",
						"Product.account",
						"Product.accountingUnit",
						"Product.discountsAllowed",
						"Product.clearingDate",
						"Product.clearingNumber",
						"Product.purchasingPrice",
						"Product.currencyId",
						"Product.taxFreeValue",
						"Product.visitProduct",
						"Product.viewId",
						"Product.iecNorm",
						"Product.enNorm",
						"Product.etsiNorm",
						"Product.iecPuzNorm",
						"Product.iecNormStatus",
						"Product.enNormStatus",
						"Product.maxOrderValue",
						"Product.productQuantityLimit",
						"Product.supplier",
						"Product.pdfTemplateId",
						"Product.showShopNotification",
						"Product.startDate",
						"Product.onlyMainStorageInShop",
						"Product.hideQuantityInShop",
						"Product.createdBy",
						"Product.eanCode",
						"Product.availableIn"]&';
	
	$km_products = $km_api->km_get_request('model/Product?'.$select.'limit=10&skip='.$skip);
	// print_r($km_products);
	$total_synced = 0;  
	if($km_api->response_code == 200){
		$total_product = count($km_products);
		if(!empty($km_products)){ 
			foreach($km_products as $i=>$km_produc){
				$wc_product_id = $km_pro_sync->km_update_product($km_produc);
				 
				if($wc_product_id){
					$total_synced++;
				}
			}
		}
		$skip = $skip + $total_synced;
		
		 return array("status"=>1,"message"=>"","total_product"=>$total_product,"total_synced"=>$total_synced,"skip"=>$skip);
		
	}else{		 
		return array("status"=>0,"message"=>$km_api->response_message,"response_code"=>$km_api->response_code);
	}  
	}
endif;

if(!function_exists('kundenmeister_sync_products_ajax')):
function kundenmeister_sync_products_ajax(){
	$skip = isset($_POST["skip"])? $_POST["skip"] : 0;	
	$res = kundenmeister_sync_products($skip);
	echo json_encode($res);
	die();
}
endif;
add_action('wp_ajax_km_sync_products','kundenmeister_sync_products_ajax');
//add_action('wp_ajax_km_sync_products','km_sync_products');
 
/* Set Cron  */ 
if(!function_exists('kundenmeister_custom_cron_schedule')):
function kundenmeister_custom_cron_schedule( $schedules ) {
    $schedules['every_six_hours'] = array(
        'interval' => 21600, // Every 6 hours
        'display'  =>'Every 6 hours',
    );
	$schedules['every_twelve_hours'] = array(
        'interval' => 43200, // Every 12 hours
        'display'  => 'Every 12 hours',
    );
    return $schedules;
}
endif;
add_filter( 'cron_schedules', 'kundenmeister_custom_cron_schedule' );

// Schedule the event if it is not scheduled.
		 
if (!wp_next_scheduled( 'kundenmeister_sync_products_cron',array(0)) ) {
// wp_schedule_event( time(), 'every_twelve_hours', 'kundenmeister_sync_products_cron',array(0));

	wp_schedule_event( strtotime('01:00:00'), 'daily', 'kundenmeister_sync_products_cron',array(0));  
	wp_schedule_event( strtotime('13:00:00'), 'daily', 'kundenmeister_sync_products_cron',array(0)); 
} 
 

 
add_action('kundenmeister_sync_products_cron', 'kundenmeister_sync_products_cron',10,1); 
if(!function_exists('km_sync_products_cron')):
function km_sync_products_cron($skip){		
	
	$km_accessToken = get_option('km_accessToken');
	if(!empty($km_accessToken)){		
		$timeIn_new = time();
		$res = km_sync_products($skip);
		$log = print_r($res,true);
		//error_log($log,1,'nimesh.alloxes@gmail.com');	
		
		 if($res["status"] == 0  && !empty($res["response_code"]) &&  $res["response_code"] !== 200){		
			wp_schedule_single_event($timeIn_new,"kundenmeister_sync_products_cron",array($skip));
		} 		
		if($res["status"] == 1  && $res["total_product"] == 10){	
			$skip = $res["skip"];
			wp_schedule_single_event($timeIn_new,"kundenmeister_sync_products_cron",array($skip));		
		} 
		
	}		
}

endif;
?>